#include <iostream>

using namespace std;

int main()
{
    int n,q,mm=0;
    cin>>n>>q;
    int d[n]={},p[n]={},k[q]={},meg[q]={};
    for(int i=0;i<n;i++){
        cin>>d[i]>>p[i];
    }
    for(int i=0;i<q;i++){
        cin>>k[i];if(k[i]>=mm){mm=k[i];}
    }
    int plazma[mm]={};
    for(int i=0;i<n;i++){
        for(int j=0;j<p[i];j++){
            plazma[d[i]-1+j]=1;
        }
    }
    for(int i=0;i<q;i++){
        for(int j=0;j<k[i];j++){
            if(plazma[j]!=0){
                meg[i]++;
            }
        }
    }
    for(int i=0;i<q;i++){
        cout<<meg[i]<<endl;
    }
}